* PROCEDURE sdf2dbf2
* Take a SDF text file and create a DBF.
PARAMETERS sdf_name, header_name
SET TALK OFF
IF PARAMETERS() << 2 OR EMPTY(sdf_name) OR ;
                        EMPTY(header_name)
WAIT WINDOW "Useage is: DO sdf2dbf WITH <<sdf_file>>," + ;
            "<<dbf_header_file>>"<F63>
RETURN
ENDIF
PRIVATE m.num_lines, m.line_len, m.header_size, ;
        m.rec_size, m.final_size, m.h, m.h2, m.h3, ;
        m.buffer, m.first_time, m.read_position, ;
        m.write_position, m.buffer, m.nul
USE (m.header_name)
m.rec_size    = RECSIZE()
m.header_size = HEADER()
USE
m.h2        = FOPEN(m.header_name)
m.header    = FREAD(m.h2,64000)
m.h         = FOPEN(m.sdf_name,2)
m.buffer    = FGETS(m.h,64000)
m.line_len  = LEN(m.buffer)
m.file_len  = FSEEK(m.h,0,2)
m.num_lines = 0
m.h3 = FCREATE("h:\tempfile.txt")
m.nul = FSEEK(m.h,0,0)
m.nul = FWRITE(m.h3, FREAD(m.h, LEN(m.header) * ;
                          (m.rec_size+1) ) )
m.nul = FSEEK(m.h3,0,0)
m.nul = FSEEK(m.h,0,0)
m.nul = FWRITE(m.h,m.header)
m.first_time     = .T.
m.write_position = 0
m.wrong_type     = .F.

ctr = 0
DO WHILE NOT FEOF(m.h)
   ctr = ctr + 1
   IF ctr % 100 = 0
      WAIT WINDOW NOWAIT ;
                  LTRIM(TRAN(ctr,"999,999,999,999,999"))
   ENDIF

   IF NOT m.wrong_type
      IF ctr<<=LEN(m.header)
         m.nul = FWRITE(m.h," " + FGETS(m.h3))
      ELSE
         IF m.first_time
            m.first_time = .F.
            m.read_position = FSEEK(m.h,0,1)
            m.buffer = FGETS(m.h)
            m.nul = FSEEK(m.h, m.read_position, 0)
            m.nul = FWRITE(m.h, " " + m.buffer)
            m.write_position = FSEEK(m.h,0,1)
            m.read_position = m.read_position + ;
                              m.rec_size + 1
            m.nul = FSEEK(m.h, m.read_position, 0)
         ELSE
            m.buffer = FGETS(m.h)
            IF LEFT(m.buffer,1) != "1"
               m.num_lines = ctr - 1
               m.wrong_type = .T.
               m.nul = FCLOSE(m.h3)
               m.h3 = FCREATE("h:\not_1.txt")
               m.nul = FPUTS(m.h3,m.buffer)
            ELSE
               m.num_lines = ctr
               * Only write it if it's a type=1
               m.nul = FSEEK(m.h, m.write_position, 0)
               m.nul = FWRITE(m.h, " " + m.buffer)
               m.write_position = FSEEK(m.h,0,1)
               m.read_position = m.read_position + ;
                                 m.rec_size + 1
               m.nul = FSEEK(m.h, m.read_position, 0)
            ENDIF
         ENDIF
      ENDIF
   ELSE
      m.nul = FPUTS(m.h3,FGETS(m.h))
   ENDIF
ENDDO WHILE NOT FEOF()

IF m.write_position l <> 0
   m.nul = FCHSIZE(m.h, m.write_position)
ENDIF
m.nul = FCLOSE(m.h3)
m.nul = FSEEK(m.h,4,0)
m.nul = FWRITE(m.h,dec2hex(m.num_lines))
m.nul = FFLUSH(m.h)
m.nul = FCLOSE(m.h)
CLOSE ALL
FLUSH
WAIT CLEAR
SET TALK ON
RETURN
********
FUNCTION dec2hex
* We need them byte and word reversed
PARAMETERS m.number
PRIVATE m.number, m.scrap
m.scrap = 0
DECLARE ret_val[4]
ret_val = 0
ret_val[1] = INT(m.number / 2^24)
m.scrap    = MOD(m.number , 2^24)
ret_val[2] = INT(m.scrap / 2^16)
m.scrap    = MOD(m.scrap , 2^16)
ret_val[3] = INT(m.scrap / 2^8)
ret_val[4] = MOD(m.scrap , 2^8)
RETURN CHR(ret_val[4]) + CHR(ret_val[3]) + ;
       CHR(ret_val[2]) + CHR(ret_val[1])
*******

