
PROCEDURE pt_help
PARAMETERS pr_name
PRIVATE pr_name, v_name, m_name, po_name, seek_str
PRIVATE m_choice, m_ch, cur_buff, cur_curs
PRIVATE cur_exact, cur_win, m_prmpt, i, ar_help
PRIVATE max_call, m_wind

*  Copyright (c) 1992 Performance Dynamics Assoc
*  Stripped-down version of dBase IV Power Tools 
*  Help System

***  capture environment and set what we need

ON KEY LABEL F1          &&  turn off the F1 key!

cur_curs = set('cursor') = 'ON'  &&  cursor state
SET CURSOR off

cur_exact = set('exact') = 'ON'  &&  exact state
SET EXACT OFF

cur_buff = alias()           &&  current work area
cur_win = window()           &&  current window

IF type('help_dev') = 'U'   &&  no help_dev memvar
  help_dev = .f.            &&  only show help
ENDIF

***

IF readkey() = 512            &&  we are in a read
  v_name = varread()          &&  the current GET
  m_name = ''
  po_name = ''
  menu_val = ''
  m_ch = .f.
ELSE                          &&  no read?
  v_name = ''                 &&  no value for get
  m_name = menu()             &&  menu name
  po_name = popup()           &&  popup name
  menu_val = prompt()         &&  menu value
  m_ch = .f.
ENDIF

***  pad to the proper dimension

pr_name = left(pr_name + space(10),10)
v_name = left(v_name + space(10),10)
m_name = left(m_name + space(10),10)
po_name = left(po_name + space(10),10)
menu_val = left(menu_val + space(10),10)

***  build our initial search string

seek_str = pr_name+ v_name + m_name + po_name

SELECT help             &&  database already open
SEEK seek_str           &&  search for match

***  for detailed menu help do a second seek

IF found() .and. menu_ch
  seek_str = seek_str + menu_val
  SEEK seek_str
  m_ch = .t.                  &&  change our flag
ENDIF

IF .not. help_dev      &&  if not in help dev
  DO hp_pop            &&  show the help
ELSE                   &&  if in help development
  DO hp_dev            &&  develop the help
ENDIF

***  reset the environment before we leave!

IF isblank(cur_buff)
  SELECT select()
ELSE
  SELECT(cur_buff)
ENDIF

IF cur_curs                &&  reset cursor
  SET CURSOR on
ENDIF

IF cur_exact               &&  reset exact
  SET EXACT ON
ENDIF

IF isblank(cur_win)        &&  screen was active
  ACTIVATE SCREEN
ENDIF

***  reactivate the help ON KEY LABEL

ON KEY LABEL F1 DO pt_help WITH program()  && reset help

RETURN

********  eop pt_help


